<template>
  <div class="auction-single">
    <h1>Auction Details</h1>

    <div class="alert alert-success" role="alert" v-if="!!message && message.type == 'success'">{{message.msg}}</div>
    <div class="alert alert-danger" role="alert" v-if="!!message && message.type == 'danger'">{{message.msg}}</div>

    <ul>
      <li>Description: {{auction.description}}</li>
      <li>Closing Date: {{auction.closing_date}}</li>
      <li>Current Price: {{currentPrice}}</li>
      <li>Initial Price: {{auction.price}}</li>
    </ul>

    <div class="form-group row">
      <div class="col-sm-8">
        <input type="text" v-model="offeredBid" class="form-control" id="offeredBid">
      </div>
      <div class="col-sm-4">
        <button id="submit-bid" type="submit"  class="btn btn-info" v-on:click="startBidding">Bid</button>
      </div>
    </div>
    <router-link id="btn-back" class="go-back" :to="{ name: 'auctions'}">Go BACK</router-link>
    <table class="table table-bordered" v-if="!!id">
      <thead>
        <tr>
          <th>Username</th>
          <th>Amount</th>
          <th>Bid Date</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="bid in auction.bids" :key="bid.id">
          <td>{{bid.user.username}}</td>
          <td>{{bid.price}}</td>
          <td>{{bid.updated_at}}</td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
  import axios from "axios";

  export default{
    data: function(){
      return {
        auction: null,
        offeredBid: null,
        currentPrice: null,
        message: null,
        id: window.localStorage.getItem('auction_id')
      }
    },
    methods: {
      getAuction: function(){
        axios.get("/api/auction/"+this.id)
          .then(response => {
              console.log(response);
              this.auction = response.data.auction;
              if(this.auction.bids.length > 0){
                let maxBid = this.auction.price;
                this.auction.bids.forEach(function(elem){
                  if(elem.price > maxBid) maxBid = elem.price;
                })
                this.currentPrice = maxBid;
              }else {
                this.currentPrice = this.auction.price;
              }
          })
          .catch(error => {
              console.log(error);
          });
      },
      startBidding: function(){
        if(!!this.offeredBid && this.offeredBid>0){
          axios.patch("/api/auction/"+this.id, {new_bid: this.offeredBid})
            .then(response => {
                console.log(response);
                this.message = {msg: response.data.msg, type: 'success'};
            })
            .catch(error => {
                console.log(error);
                this.message = {msg: "Denied!", type: 'danger'};
            });
          this.getAuction()
        }
      }
    },
    mounted: function(){
      let id = this.$route.params.id;
      if(!!id){
        window.localStorage.setItem('auction_id', id);
        this.id = window.localStorage.getItem('auction_id')
      }
      this.getAuction()
      // console.log(this.id);
    }
  }

</script>
